import { Matrix4, Vector3 } from '@math.gl/core';
import { ShaderModule } from "../../../lib/shader-module/shader-module.js";
import type { NumberArray3, NumberArray16 } from "../../../lib/utils/uniform-types.js";
/**
 * @note Projection uniforms are normally constant across draw calls,
 * at least for each view.
 */
export type ProjectionProps = {
    viewMatrix?: Readonly<Matrix4 | NumberArray16>;
    projectionMatrix?: Readonly<Matrix4 | NumberArray16>;
    cameraPositionWorld?: Readonly<Vector3 | NumberArray3>;
};
/**
 * @note Projection uniforms are normally constant across draw calls,
 * at least for each view.
 */
export type ProjectionUniforms = {
    viewMatrix?: Readonly<Matrix4 | NumberArray16>;
    projectionMatrix?: Readonly<Matrix4 | NumberArray16>;
    viewProjectionMatrix?: Readonly<Matrix4 | NumberArray16>;
    cameraPositionWorld?: Readonly<Vector3 | NumberArray3>;
};
/**
 * Projects coordinates
 */
export declare const projection: ShaderModule<ProjectionProps, ProjectionUniforms>;
//# sourceMappingURL=project.d.ts.map